## Homepage of

# xorriso

## ISO 9660 Rock Ridge Filesystem Manipulator for Linux and FreeBSD

## Purpose:

xorriso copies file objects from POSIX compliant filesystems into Rock Ridge enhanced ISO 9660 filesystems and allows session-wise manipulation of such filesystems. It can load the management information of existing ISO images and it writes the session results to optical media or to filesystem objects.
Vice versa xorriso is able to copy file objects out of ISO 9660 filesystems.

Direct hop to download links ->

## Hardware requirements:

About any CD, DVD, or BD recorder produced in the recent ten years.
libburn supports recorders which are compliant to standards MMC-1 for CD and MMC-5 for DVD or BD. Linux and FreeBSD allow to access drives connected via SCSI, PATA (aka IDE, ATA), USB, or SATA.

## Software requirements :

Linux with kernel 2.4 or higher, libc, libpthread :
  With kernel 2.4 an ATA drive has to be under ide-scsi emulation.
  With kernel 2.6 ide-scsi is not needed.
or FreeBSD, libc, libpthread :
  PATA/IDE and SATA drives need atapicam running.
  libcam has to be installed.
  libiconv has to be installed.
or some other X/Open system, libc, libpthread :
  There will be no direct operation of optical drives, but only POSIX i/o with objects of the local filesystem.
  Might work with DVD-RAM, DVD+RW, BD-RE but rather not with CD, DVD-R, DVD+R, BD-R.

### Optional supporting software:

libreadline and libreadline-dev
  eventually make dialog more convenient.
libacl and libacl-devel
  eventually allow on Linux to get and set ACLs.
zlib and zlib-devel
  eventually allow zisofs and gzip compression.

This program has been tested on Linux, FreeBSD, and Solaris systems.
For ports to other usable systems contact us.

## Special features:

- ISO 9660 formatter and burner for CD, DVD, BD are fixely integrated.
- Operates on an existing ISO image or creates a new one.
- Copies files from filesystem into the ISO image and vice versa.
- Changes file properties, renames or deletes file objects in the ISO image.
- Updates ISO subtrees incrementally to match given disk subtrees.
- Can record and restore hard link relations, ACL, and xattr.
- Can attach MD5 checksums to each data file and the whole session.
- File content may get zisofs or gzip compressed or filtered by external processes.
- Writes result as completely new image or as add-on session to optical media or filesystem objects.
- Can activate ISOLINUX boot images by El Torito boot record.
- Can perform multi-session tasks as emulation of mkisofs and cdrecord.
- Can issue commands to mount older sessions on Linux or FreeBSD.
- Can check media for damages and copy readable blocks to disk.
- Scans for optical drives, blanks re-useable optical media, formats media.
- Suitable for: CD-R, CD-RW, DVD-R, DVD-RW, DVD+R, DVD+R DL, DVD+RW, DVD-RAM, BD-R, BD-RE.
- Reads its instructions from command line arguments, dialog, and batch files.
- Provides navigation commands for interactive ISO image manipulation.

## Command Examples:

Get an overview of drives and their addresses
  #`xorriso -devices`
  `...`
  `0 -dev '/dev/sr0' rwrw-- : 'TSSTcorp' 'CDDVDW SH-S203B'`
  `1 -dev '/dev/scd1' rwrw-- : 'PHILIPS ' 'SPD3300L'`
  `2 -dev '/dev/hda' rwrw-- : 'HL-DT-ST' 'DVD-ROM GDR8162B'`
  `...`
Being superuser avoids permission problems with /dev/srN resp. /dev/hdX .
Ordinary users should then get granted rw access to the /dev files as listed by option -devices.
Options are either performed as program arguments or as dialog input. Some options have a parameter list of variable length. This list has to be terminated by word '--' or by the end of the input line. Option -add may accept pathspecs of form target=source as known from program mkisofs.

Get info about a particular drive and loaded media:
  $`xorriso -indev /dev/sr0 -du / -- -toc 2>&1 | less`
Make re-usable media writable again, delete any ISO 9660 image, eventually prepare yet unused BD-RE:
  $`xorriso -outdev /dev/sr0 -blank as_needed -eject all`

Write some directories into a new or existing ISO 9660 image:
  $`xorriso -dev /dev/sr0 -add /home/me/sounds /home/me/pictures`
Have a look at the result:
  $`xorriso -indev /dev/sr0 -du / -- -toc 2>&1 | less`

Create new ISO-9660 filesystem image, compose content, adjust permissions to make it publicly read-only, write it to media and immediately eject media without previously reloading the written image.
  $`cd /home/me`
  $`xorriso -outdev /dev/sr0 -blank as_needed \`
  `-map /home/me/sounds /sounds \`
  `-map /home/me/pictures /pictures \`
  `-rm_r /sounds/indecent '/pictures/*private*' -- \`
  `-cd / \`
  `-add pictures/private/horses* -- \`
  `-chmod_r a+r,a-w / -- \`
  `-find / -type d -exec chmod a+x -- \`
  `-volid SOUNDS_PICS_2008_01_16 \`
  `-commit_eject all`

Load the previous session from media, remove (i.e. hide) directory /sounds, rename /pictures/private/horses, add new directory trees /sounds and /movies, disallow any access for group and others. Finally write as additional session to media and eject:
  $`xorriso -dev /dev/sr0 \`
  `-rm_r /sounds -- \`
  `-mv /pictures/private/horses /horse_show -- \`
  `-map /home/me/prepared_for_dvd/sounds_dummy /sounds \`
  `-map /home/me/prepared_for_dvd/movies /movies \`
  `-chmod_r go-rwx / -- \`
  `-volid SOUNDS_PICS_2008_01_17 \`
  `-commit_eject all`

Merge the various sessions from old readable media into a single session on new writeable media, cleaning out all invalidated files and session overhead. Touch / in order to mark the image as worth to be written.
Important: -indev and -outdev have to be different drives.
  $`xorriso -indev /dev/dvd \`
  `-alter_date a +0 / -- \`
  `-outdev /dev/sr0 -blank fast \`
  `-commit_eject all`

Dialog mode accepts one or more options per line. An option and all its arguments have to be given in one single line. Backslash may be used to mark a line as incomplete so it gets continued by the next input line.
Command -end stops the program run. It will write eventually pending changes to media, if that has not already been done by a previous -commit.
  $`xorriso -dialog on`
  `enter option and arguments :`
  `-dev /dev/sr0`
  `enter option and arguments :`
  `-map /home/me/prepared_for_dvd/sounds_dummy /sounds`
  `enter option and arguments :`
  `-map /home/me/prepared_for_dvd/movies \`
  `Trailing backslash : Enter rest of line (or @@@ to clear it) :`
  `/movies`
  Available navigation commands: -cd, -ls, -du, -find
  `enter option and arguments :`
  `-commit`
  ... perform further commands and finally do:
  `enter option and arguments :`
  `-end`

The following command performs incremental backup. It can be run on blank media to create a copy of the mentioned disk directory trees, and it can be run on appendable media to perform a minimal set of change operations which update the old ISO copies to match the new disk trees. Older states can be retrieved by help of mount options like "sbsector=" or by help of xorriso option -mount.
Eventual ACL, xattr and hardlink relations will be recorded. MD5 checksums will be computed and recorded. Data comparison will be avoided by accelerator option -disk_dev_ino. After writing, the new session will be checked by its recorded MD5.
Only blank media or media with volume id "PROJECTS_MAIL_..." will be accepted. Files with names ending by ".o" or ".swp" are excluded by options -not_leaf.
  $`xorriso -for_backup -disk_dev_ino on \`
  `-assert_volid 'PROJECTS_MAIL_*' FATAL \`
  `-dev /dev/sr0 \`
  `-volid PROJECTS_MAIL_"$(date '+%Y_%m_%d_%H%M%S')" \`
  `-not_leaf '*.o' -not_leaf '*.swp' \`
  `-update_r /home/thomas/open_source_projects /open_source_projects \`
  `-update_r /home/thomas/personal_mail /personal_mail \`
  `-commit -toc -check_md5 FAILURE -- -eject all`
To apply zisofs compression to those data files which get newly copied from the local filesystem, perform immediately before -commit :
  `-hardlinks perform_update \`
  `-find / -type f -pending_data -exec set_filter --zisofs -- \`

Operating systems usually mount the most recent session on media. xorriso can issue the appropriate mount commands for older sessions. First get an overview of the sessions on the media:
  $`xorriso -outdev /dev/sr0 -toc`

    TOC layout   : Idx ,  sbsector ,       Size , Volume Id
    ISO session  :   1 ,         0 ,    104719s , PROJECTS_MAIL_2008_08_10_231435
    ISO session  :   2 ,    106928 ,      6785s , PROJECTS_MAIL_2008_08_14_184548
    ...
    ISO session  :  76 ,    820384 ,     11035s , PROJECTS_MAIL_2009_01_04_191150

Then become superuser and let xorriso mount the session of August 14, 2008 to directory /mnt:
  #`xorriso -osirrox on -mount /dev/sr0 volid '*_2008_08_14_*' /mnt`
To be later unmounted by: `umount /mnt`

After the user has already created a suitable file tree on disk and copied the ISOLINUX files into subdirectory ./boot/isolinux of that tree, xorriso can burn an El Torito bootable media:
  $`xorriso -outdev /dev/sr0 -blank as_needed \`
  `-map /home/me/ISOLINUX_prepared_tree / \`
  `-boot_image isolinux dir=/boot/isolinux`
An additional MBR is generated if the file isolinux.bin is modern enough (syslinux version 3.72) and ready for "isohybrid". An MBR enables booting from hard disk or USB stick.

ISO images may not only be stored on optical media but also in regular disk files or block devices for full multi-session operation.
  $`xorriso -dev /tmp/regular_file ...other.options...`
A default setting for safety reasons requires that files below /dev/ need prefix "stdio:" if they do not lead to MMC burner devices. Be cautious not to overwrite your hard disk instead of your USB stick:
  $`xorriso -dev stdio:/dev/sdb ...other.options...`
Other file types are suitable only for writing but not for reading:
  $`xorriso -outdev /tmp/named_pipe ...other.options...`
In batch mode it is possible to operate xorriso in a pipeline with an external consumer of the generated ISO image. Any message output will be redirected to stderr in this case. Examples for consumers are cdrecord or growisofs on operating systems where xorriso cannot operate the burner drive directly, or a ssh pipe to another system which has the desired drive and a suitable burn program.
  $`xorriso -outdev - ...other.options... | consumer`

Let xorriso serve underneath growisofs via its alias name "xorrisofs" which enables mkisofs emulation:
  $`export MKISOFS="xorrisofs"`
  $`growisofs -Z /dev/dvd /some/files`
  $`growisofs -M /dev/dvd /more/files`
One may switch from mkisofs emulation to xorriso's own command mode:
  $`growisofs -M /dev/dvd -- outdev - -update_r /my/files /files`

If for any reason the reading operating system mishandles the ISO image or some files in it, one may enable reverse operation of xorriso and copy files or trees to disk:
  $`xorriso -acl on -xattr on \`
  `-indev /dev/sr0 \`
  `-osirrox on \`
  `-cpx '/pictures/private/horses*/*buttercup*' \`
  `/home/her/buttercup_dir -- \`
  `-extract /sounds /home/her/sounds_from_me`
Consider to enter dialog mode and use commands like `-cd , -du , -lsl , -find`.``

Get overview of the options:
  $`xorriso -help`
Read the detailed manual page:
  $`man xorriso`

### Download as source code (see README):

  xorriso-0.4.8.pl00.tar.gz (1360 KB).
  (Released 25 Jan 2010)

Documentation:
  README about installation and drive setup
  xorriso -help gives an overview of options
  man xorriso is the manual page

Contact:
  Thomas Schmitt, scdbackup@gmx.net
  libburn development mailing list, libburn-hackers@pykix.org

License:
  GPL version 2 or later, an Open Source approved license

Bug fixes towards xorriso-0.4.6.pl00:

- With non-Linux system adapters there were 0 readable bytes on block devices which acted as pseudo drives.
- xorriso did not blank CD-RW with images that were prepared on hard disk
- Invalid checksum tags were preserved if the new session produced no checksums

Enhancements towards previous stable version xorriso-0.4.6.pl00:

- New configure option --enable-libcdio for system adapter to libcdio-0.83git
- The checksum buffer for the emerging image gets now marked as invalid if image generation is canceled.
- More graceful reaction on filesystems where ACL are not enabled but nevertheless requested by the application.
- Made FreeBSD system adapter safe from mutal burn spoiling and drive deadlock.

### Library copies included in xorriso tarballs:

libburn-0.7.7
  reads and writes data from and to CD, DVD, BD.
  (founded by Derek Foreman and Ben Jansens, developed and maintained since August 2006 by Thomas Schmitt from team of libburnia-project.org)
libisofs-0.6.27
  operates on ISO 9660 filesystem images.
  (By Vreixo Formoso, Mario Danic and Thomas Schmitt from team of libburnia-project.org)
libisoburn-0.4.6
  coordinates libburn and libisofs, emulates multi-session where needed.
  (By Vreixo Formoso and Thomas Schmitt from team of libburnia-project.org)
The source code of this software is independent of cdrecord and mkisofs.

### Development snapshot, version 0.4.9 :

  Bug fixes towards xorriso-0.4.8.pl00:
  - - none yet -
  Enhancements towards stable version 0.4.8.pl00:
  - - none yet -
  README 0.4.9
  xorriso_0.4.9 -help
  man xorriso (as of 0.4.9)
If you want to distribute development versions of xorriso, then use this tarball which produces static linking between xorriso and the libburnia libraries.
  Source (./bootstrap is already applied, build tested, installation see README)
  xorriso-0.4.9.tar.gz (1360 KB).
A dynamically linked development version of xorriso can be obtained from repositories of libburnia-project.org. xorriso is part of libisoburn/trunk and will get built by its "make".
Be warned that the libraries in SVN and bzr are development versions with possibly unstable API/ABI enhancements. Do not distribute development versions for dynamic linking. Only release versions are safe for that.
  Download: `svn co http://svn.libburnia-project.org/libburn/trunk libburn`
  Install: `cd libburn ; ./bootstrap ; ./configure --prefix /usr ; make ; make install`
  Download: `bzr branch lp:~libburnia-team/libisofs/scdbackup`
  Install: `cd libisofs ; ./bootstrap ; ./configure --prefix /usr ; make ; make install`
  Download: `svn co http://svn.libburnia-project.org/libisoburn/trunk libisoburn`
  Install: `cd libisoburn ; ./bootstrap ; ./configure --prefix /usr ; make ; make install`
Build of SVN versions needs autotools of at least version 1.7 installed. But after the run of `./bootstrap`, only vanilla tools like make and gcc are needed.

Many thanks to Derek Foreman and Ben Jansens for starting libburn.
Very special thanks to Andy Polyakov whose dvd+rw-tools provide the libburnia project with invaluable examples on how to deal with DVD media and how to emulate multi-session on overwriteable media.

Enjoying free Open Source hosting by www.webframe.org
and by sourceforge.net

Enjoying a FreeBSD shell account with the opportunity to build, install and test xorriso at
free-shells.com.ar

Links to my other published software projects :
  cdrskin, a cdrecord emulator
  scdbackup, multi volume CD backup

  (a second source of above)

  Some Tools for Image Collectors
  pppoem, a DSL throughput monitor (mainly for Linux kernel 2.4)

Legal statement: This website does not serve any commercial purpose.